#!/bin/sh
# ICMP MTFirewall
#
#    Copyright (c) 2002, Manfred Tremmel
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#
# Author: Manfred Tremmel <Manfred.Tremmel@iiv.de>
#

ALLOW_ROUTE=$1

${IPTABLES}	-A INPUT		--protocol icmp	--icmp-type echo-reply		-m limit --limit 1/second	-j ACCEPT
${IPTABLES}	-A INPUT		--protocol icmp	--icmp-type destination-unreachable							-j ACCEPT
${IPTABLES}	-A INPUT		--protocol icmp	--icmp-type echo-request	-m limit --limit 1/second	-j ACCEPT
${IPTABLES}	-A INPUT		--protocol icmp	--icmp-type time-exceeded										-j ACCEPT

if test X$ALLOW_ROUTE = "Xyes"; then
	${IPTABLES}	-A FORWARD	--protocol icmp	--icmp-type echo-reply										-j ACCEPT
	${IPTABLES}	-A FORWARD	--protocol icmp	--icmp-type destination-unreachable						-j ACCEPT
	${IPTABLES}	-A FORWARD	--protocol icmp	--icmp-type echo-request									-j ACCEPT
	${IPTABLES}	-A FORWARD	--protocol icmp	--icmp-type time-exceeded									-j ACCEPT
fi
${IPTABLES}	-A OUTPUT	--protocol icmp	--icmp-type echo-reply		-m limit --limit 1/second	-j ACCEPT
${IPTABLES}	-A OUTPUT	--protocol icmp	--icmp-type destination-unreachable							-j ACCEPT
${IPTABLES}	-A OUTPUT	--protocol icmp	--icmp-type echo-request	-m limit --limit 1/second	-j ACCEPT
${IPTABLES}	-A OUTPUT	--protocol icmp	--icmp-type time-exceeded										-j ACCEPT
