#!/bin/sh
# Init MTFirewall
#
#    Copyright (c) 2002, Manfred Tremmel
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#
# Author: Manfred Tremmel <Manfred.Tremmel@iiv.de>
#

DEV_INET=$1
LNET=$2

${IPTABLES}	-F
${IPTABLES}	-t nat -F

for i in $DEV_INET ; do
	${IPTABLES}	-t nat -A POSTROUTING	-o $i	-s $LNET	-j MASQUERADE
done

${IPTABLES}	-P INPUT		DROP
${IPTABLES}	-P OUTPUT	DROP
${IPTABLES}	-P FORWARD	DROP

${IPTABLES}	-t nat	-P PREROUTING	ACCEPT
${IPTABLES}	-t nat	-P POSTROUTING	ACCEPT

for i in $DEV_INET ; do
	${IPTABLES}	-A FORWARD	-i $i	-m state --state NEW,INVALID		-j DROP
done
${IPTABLES}	-A FORWARD	-m state --state ESTABLISHED,RELATED	-j ACCEPT

${IPTABLES}	-A INPUT		-m unclean	-j DROP

for i in $DEV_INET ; do
	${IPTABLES}	-t nat -A PREROUTING	-i $i	-s 192.168.0.0/16	-j DROP
	${IPTABLES}	-t nat -A PREROUTING	-i $i	-s 10.0.0.0/8		-j DROP
	${IPTABLES}	-t nat -A PREROUTING	-i $i	-s 172.16.0.0/12	-j DROP
	${IPTABLES}	-t nat -A PREROUTING	-i $i	-s 127.0.0.0/8		-j DROP
done
