#!/bin/sh
# NFS MTFirewall
#
#    Copyright (c) 2002, Manfred Tremmel
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA
#
# Author: Manfred Tremmel <Manfred.Tremmel@iiv.de>
#

DEVICE=$1
SENDER=$2
RECEIVER=$3
NET=$4

NFS_MOUNTDS="1 2 3 4"
NFS_MOUNTPROTS="udp tcp"

# NFS-Protokoll (UDP und TCP)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "nfs" "0:" "udp"
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "nfs" "0:" "tcp"

# mdbs_daemon-Protokoll (UDP und TCP)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "mdbs_daemon" "1024:" "udp"
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "mdbs_daemon" "1024:" "tcp"

# kerberos-adm-Protokoll (TCP)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "kerberos-adm" "1024:" "tcp"

# who is-Protokoll (UDP)
RECEIVER_255="`$IFCONFIG $DEVICE | { read; read -a A; echo ${A[2]#*:};}`"
/usr/sbin/mtfirewall/someports_iptables_client.sh $DEVICE $SENDER $RECEIVER_255 $NET "who" "who" "udp"

# sunrpc-Protokoll (TCP und UDP)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "sunrpc" "0:" "tcp"
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "sunrpc" "0:" "udp"

# Port 715 (TCP, Server)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "715" "0:1023" "tcp"

# Dynamische Mountports der NFS-Partner (mountd) wenn erreichbar
if /bin/ping -q -c 1 $SENDER -w 2 >/dev/null 2>&1; then
	for ni in $NFS_MOUNTDS ; do
		for nj in $NFS_MOUNTPROTS; do
			mountdport="`/usr/sbin/rpcinfo -p $SENDER |/usr/bin/awk '/100005    '$ni'   '$nj'/ {print $4}'`"
			if test $mountdport; then
				/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET $mountdport "0:1023" $nj
			fi
		done
	done
fi

# Port 65535 <-> 65535 Kommunikation (udp)
/usr/sbin/mtfirewall/someports_iptables_server.sh $DEVICE $SENDER $RECEIVER $NET "65535" "65535" "udp"
